Apache log4cxx: PatternLayout Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# PatternLayout Class Reference

Inherits Layout.

List of all members.

## Detailed Description

A flexible layout configurable with pattern string.

The goal of this class is to format a LoggingEvent and return the results as a string. The results depend on the conversion pattern.

The conversion pattern is closely related to the conversion pattern of the printf function in C. A conversion pattern is composed of literal text and format control expressions called conversion specifiers.

You are free to insert any literal text within the conversion pattern.

Each conversion specifier starts with a percent sign (%) and is followed by optional format modifiers and a conversion character. The conversion character specifies the type of data, e.g. logger, level, date, thread name. The format modifiers control such things as field width, padding, left and right justification. The following is a simple example.

Let the conversion pattern be "\%-5p [\%t]: \%m\%n" and assume that the log4cxx environment was set to use a PatternLayout. Then the statements

            LoggerPtr root = Logger::getRoot();
            root->debug("Message 1");
            root->warn("Message 2");

would yield the output

            DEBUG [main]: Message 1
            WARN  [main]: Message 2

Note that there is no explicit separator between text and conversion specifiers. The pattern parser knows when it has reached the end of a conversion specifier when it reads a conversion character. In the example above the conversion specifier %-5p means the level of the logging event should be left justified to a width of five characters.

The recognized conversion characters are

Conversion Character | Effect
c | Used to output the logger of the logging event. The logger conversion specifier can be optionally followed by precision specifier, that is a decimal constant in brackets. If a precision specifier is given, then only the corresponding number of right most components of the logger name will be printed. By default the logger name is printed in full. For example, for the logger name "a.b.c" the pattern %c{2} will output "b.c".
d | Used to output the date of the logging event. The date conversion specifier may be followed by a set of braces containing a date and time pattern string compatible with java.text.SimpleDateFormat, ABSOLUTE, DATE or ISO8601. For example, d{HH:mm:ss,SSS}, d{dd MMM yyyy HH:mm:ss,SSS} or d{DATE}. If no date format specifier is given then ISO8601 format is assumed.
F | Used to output the file name where the logging request was issued.
l | Used to output location information of the caller which generated the logging event.
L | Used to output the line number from where the logging request was issued.
m | Used to output the application supplied message associated with the logging event.
n | Outputs the platform dependent line separator character or characters. This conversion character offers practically the same performance as using non-portable line separator strings such as "\n", or "\r\n". Thus, it is the preferred way of specifying a line separator.
p | Used to output the level of the logging event.
r | Used to output the number of milliseconds elapsed since the start of the application until the creation of the logging event.
t | Used to output the name of the thread that generated the logging event.
x | Used to output the NDC (nested diagnostic context) associated with the thread that generated the logging event.
X | Used to output the MDC (mapped diagnostic context) associated with the thread that generated the logging event. The X conversion character must be followed by the key for the map placed between braces, as in %X{clientNumber} where `clientNumber` is the key. The value in the MDC corresponding to the key will be output. See MDC class for more details.
% | The sequence %% outputs a single percent sign.

By default the relevant information is output as is. However, with the aid of format modifiers it is possible to change the minimum field width, the maximum field width and justification.

The optional format modifier is placed between the percent sign and the conversion character.

The first optional format modifier is the left justification flag which is just the minus (-) character. Then comes the optional minimum field width modifier. This is a decimal constant that represents the minimum number of characters to output. If the data item requires fewer characters, it is padded on either the left or the right until the minimum width is reached. The default is to pad on the left (right justify) but you can specify right padding with the left justification flag. The padding character is space. If the data item is larger than the minimum field width, the field is expanded to accommodate the data. The value is never truncated.

This behavior can be changed using the maximum field width modifier which is designated by a period followed by a decimal constant. If the data item is longer than the maximum field, then the extra characters are removed from the beginning of the data item and not from the end. For example, it the maximum field width is eight and the data item is ten characters long, then the first two characters of the data item are dropped. This behavior deviates from the printf function in C where truncation is done from the end.

Below are various format modifier examples for the logger conversion specifier.

Format modifier | left justify | minimum width | maximum width | comment
%20c | false | 20 | none | Left pad with spaces if the logger name is less than 20 characters long.
%-20c | true | 20 | none | Right pad with spaces if the logger name is less than 20 characters long.
%.30c | NA | none | 30 | Truncate from the beginning if the logger name is longer than 30 characters.
%20.30c | false | 20 | 30 | Left pad with spaces if the logger name is shorter than 20 characters. However, if logger name is longer than 30 characters, then truncate from the beginning.
%-20.30c | true | 20 | 30 | Right pad with spaces if the logger name is shorter than 20 characters. However, if logger name is longer than 30 characters, then truncate from the beginning.

Below are some examples of conversion patterns.

%r [%t] %-5p %c %x - %m

This is essentially the TTCC layout.

%-6r [%15.15t] %-5p %30.30c %x - %m

Similar to the TTCC layout except that the relative time is right padded if less than 6 digits, thread name is right padded if less than 15 characters and truncated if longer and the logger name is left padded if shorter than 30 characters and truncated if longer.

The above text is largely inspired from Peter A. Darnell and Philip E. Margolis' highly recommended book "C -- a Software Engineering Approach", ISBN 0-387-97389-3.

## Public Member Functions
| PatternLayout ()
| Does nothing.
| PatternLayout (const LogString &pattern)
| Constructs a PatternLayout using the supplied conversion pattern.
void | setConversionPattern (const LogString &conversionPattern)
| Set the ConversionPattern option.
LogString | getConversionPattern () const
| Returns the value of the ConversionPattern option.
virtual void | activateOptions (log4cxx::helpers::Pool &p)
| Call createPatternParser.
virtual void | setOption (const LogString &option, const LogString &value)
| Set `option` to `value`.
virtual bool | ignoresThrowable () const
| The PatternLayout does not handle the throwable contained within LoggingEvents.
virtual void | format (LogString &output, const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &pool) const
| Produces a formatted string as specified by the conversion pattern.
## Protected Member Functions
virtual log4cxx::pattern::PatternMap | getFormatSpecifiers ()

## Constructor & Destructor Documentation

PatternLayout | ( |  | ) |

| Does nothing.

PatternLayout | ( | const LogString & | pattern | ) |

| Constructs a PatternLayout using the supplied conversion pattern.

## Member Function Documentation

virtual void activateOptions | ( | log4cxx::helpers::Pool & | p | ) | `[virtual]`

| Call createPatternParser. Implements OptionHandler.

virtual void format | ( | LogString & | output,
|  | const spi::LoggingEventPtr & | event,
|  | log4cxx::helpers::Pool & | pool
| ) | const`[virtual]`

| Produces a formatted string as specified by the conversion pattern. Implements Layout.

LogString getConversionPattern | ( |  | ) | const`[inline]`

| Returns the value of the ConversionPattern option.

virtual log4cxx::pattern::PatternMap getFormatSpecifiers | ( |  | ) | `[protected, virtual]`

virtual bool ignoresThrowable | ( |  | ) | const`[inline, virtual]`

| The PatternLayout does not handle the throwable contained within LoggingEvents. Thus, it returns `true`. Implements Layout.

void setConversionPattern | ( | const LogString & | conversionPattern | ) |

| Set the ConversionPattern option. This is the string which controls formatting and consists of a mix of literal content and conversion specifiers.

virtual void setOption | ( | const LogString & | option,
|  | const LogString & | value
| ) | `[virtual]`

| Set `option` to `value`. The handling of each option depends on the OptionHandler instance. Some options may become active immediately whereas other may be activated only when activateOptions is called. Implements OptionHandler.

The documentation for this class was generated from the following file:

- patternlayout.h